#ifndef TP1_EX2_COMPLEX_HPP_INCLUDED
#define TP1_EX2_COMPLEX_HPP_INCLUDED

#include <iostream>

class complex
{
public:
    complex(double,double);
    complex(double=0.0);

    complex(const complex&);
    void copy(const complex&);
    complex* clone() const;
    void operator =(const complex&);

    double real() const;
    double imag() const;

    complex& operator +=(complex);
    complex& operator -=(complex);
    complex& operator *=(complex);
    complex& operator /=(complex);
private:
    double re, im;
};

complex operator +(complex, complex);
complex operator -(complex, complex);
complex operator *(complex, complex);
complex operator /(complex, complex);

complex operator -(complex);
complex operator +(complex);

bool operator ==(complex,complex);
bool operator !=(complex,complex);

std::ostream& operator <<(std::ostream &,const complex &);
std::istream& operator >>(std::istream &,complex &);

complex polar(double rho, double theta);
complex conj(complex);
double abs(complex);
double arg(complex);
double norm(complex);

double real(complex);
double imag(complex);

#endif // TP1_EX2_COMPLEX_HPP_INCLUDED
